#!/bin/sh
# Maintained by: toleda for: github.com/toleda/graphics_Intel_framebuffers
# File: graphics_intel_hd5k_azul-90_patch.command_v2.1
# Credit: PikeRAlpha
#
# Desktop HD4600 HDMI audio AppleIntelFramebufferAzul.kext edit
# Edits Azul framebuffer 03 00 22 0D for HDMI audio, additional dsdt edits/ssdt required
# The patch enables DP, HDMI, 2XHDMI and DVI audio, however, the maximum number of audio  # devices supported is 2.
#
# NOTES: 
# 1. Run this patch file only once on a AppleIntelFramebufferAzul.kext,
#
# Requirements
# 1. 10.9+
# 2. Haswell/HD4600/HD5000 Graphics
# 3. AppleIntelFramebufferAzul.kext_v8.18.26 or newer
#
# Installation
# 1. Downloads/graphics_intel_hd5k_azul-90_patch.command
# 2. Double click graphics_intel_hd5k_azul-90_patch.command
# 3. Enter password at prompt
#
echo " "
echo "Agreement"
echo "The graphics_intel_hd5k_azul-f-90_patch is for personal use only.  Do not"
echo "distribute the patch or the resulting patched AppleIntelFramebufferAzul.kext" 
echo "for any reason without permission. The graphics_intel_hd5k_azul-f-90_patch"
echo "is provided as is and without any kind of warranty."
echo " "
echo "graphics_intel_hd5k_azul-90_patch.command_v2.1"
echo "Copy S/L/E/AppleIntelFramebufferAzul.kext to Desktop."
cp -R /System/Library/Extensions/AppleIntelFramebufferAzul.kext Desktop/AppleIntelFramebufferAzul-orig.kext

echo "Patch binary ..."
sudo perl -pi -e 's|\x00\x00\x04\x00\x00\x87\x00\x00\x00\x02\x04|\x00\x00\x08\x00\x00\x06\x00\x00\x00\x02\x04|g' /System/Library/Extensions/AppleIntelFramebufferAzul.kext/Contents/MacOS/AppleIntelFramebufferAzul

# sudo perl -pi -f 's|\x00\x00\x04\x00\x00\x87\x00\x00\x00\x03\x06|
# \x00\x00\x08\x00\x00\x06\x00\x00\x00\x03\x06|g' /System/Library/Extensions/
# AppleIntelFramebufferAzul.kext/Contents/MacOS/AppleIntelFramebufferAzul

# sudo perl -pi -f 's|\x00\x00\x04\x00\x00\x11\x00\x00\x00\xFF\x00|
# \x00\x00\x08\x00\x00\x06\x00\x00\x00\xFF\x00|g' /System/Library/Extensions/
# AppleIntelFramebufferAzul.kext/Contents/MacOS/AppleIntelFramebufferAzul

echo "Fix permissions ..."
sudo chown -R root:wheel /System/Library/Extensions/AppleIntelFramebufferAzul.kext

echo "Kernel cache..."
sudo touch /System/Library/Extensions

echo "Finished, restart required."